package com.brilliance.isc.swift.objmtconvert.model.mt7xx;

import com.brilliance.isc.swift.objmtconvert.annotation.FieldDescription;
import com.brilliance.isc.swift.objmtconvert.annotation.Status;
import com.brilliance.isc.swift.objmtconvert.annotation.TagName;
import com.brilliance.isc.swift.objmtconvert.annotation.TagRegex;
import com.brilliance.isc.swift.objmtconvert.model.AbsMTCreator;
import com.brilliance.isc.swift.objmtconvert.model.AbsTagCreate;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag798.*;
import com.brilliance.isc.swift.objmtconvert.result.MtResult;

import java.util.ArrayList;
import java.util.List;

/**
 * @author wuzhe
 * @date 2023/3/3
 */

public class MT798Creator extends AbsMTCreator {
    @Status("M")
    @TagName("20")
    @FieldDescription("Transaction Reference Number")
    @TagRegex("16x")
    //20
    private String transactionReferenceNumber;
    @Status("M")
    @TagName("12")
    @FieldDescription("Sub-Message Type")
    @TagRegex("3!n")
    //12
    private String subMessageType;
    @Status("M")
    @TagName("77E")
    @FieldDescription("Proprietary Message")
    @TagRegex("73z<crlf>[n*78z]")
    //77E
    private String proprietaryMessage;

    //20
    public String getTransactionReferenceNumber() {
        return transactionReferenceNumber;
    }

    public void setTransactionReferenceNumber(String transactionReferenceNumber) {
        this.transactionReferenceNumber = transactionReferenceNumber;
    }

    //12
    public String getSubMessageType() {
        return subMessageType;
    }

    public void setSubMessageType(String subMessageType) {
        this.subMessageType = subMessageType;
    }

    //77E
    public String getProprietaryMessage() {
        return proprietaryMessage;
    }

    public void setProprietaryMessage(String proprietaryMessage) {
        this.proprietaryMessage = proprietaryMessage;
    }

    public MT798Creator(String msgType)  {
        super(msgType);
    }

    public MT798Creator() {
        super();
    }

    /**
     * 需要编写组装报文逻辑，调用set方法即可
     *
     * @return
     */
    public void pack() {
        //MtResult mtResult = new MtResult();
        List<AbsTagCreate> tagCreateList = new ArrayList<>();
        try {
            tagCreateList.add(new Tag20Creator(this));
            tagCreateList.add(new Tag12Creator(this));
            tagCreateList.add(new Tag77ECreator(this));
            dealTags(tagCreateList);

            mtResult.setMessage(abstractMT.message());
        } catch (Exception e) {
            e.printStackTrace();
            mtResult.setSuccess(false);
            mtResult.addDescription(e.getLocalizedMessage());
        }

       // return mtResult;

    }

    public MtResult unpack() {
        return null;
    }

}

